package cn.iocoder.yudao.module.system.service.yk;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.system.controller.admin.yk.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.yk.YkElderlyDeliveryDO;
import cn.iocoder.yudao.module.system.dal.dataobject.yk.YkElderlyExpenseRecordDO;
import cn.iocoder.yudao.module.system.dal.dataobject.home.HomeElderlyInfoDO;
import cn.iocoder.yudao.module.system.dal.dataobject.yk.YkElderlyPaymentRecordDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 颐康中心长者信息服务接口
 *
 * @author 芋道源码
 */
public interface YkElderlyInfoService {

    /**
     * 创建长者信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createElderlyInfo(@Valid YkElderlyInfoSaveReqVO createReqVO);

    /**
     * 更新长者信息
     *
     * @param updateReqVO 更新信息
     */
    void updateElderlyInfo(@Valid YkElderlyInfoSaveReqVO updateReqVO);

    /**
     * 删除长者信息
     *
     * @param id 编号
     */
    void deleteElderlyInfo(Long id);

    /**
     * 获得长者信息
     *
     * @param id 编号
     * @return 长者信息
     */
    HomeElderlyInfoDO getElderlyInfo(Long id);

    /**
     * 获得长者信息分页
     *
     * @param pageReqVO 分页查询
     * @return 长者信息分页
     */
    PageResult<HomeElderlyInfoDO> getElderlyInfoPage(YkElderlyInfoPageReqVO pageReqVO);

    /**
     * 获得长者信息列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 长者信息列表
     */
    List<HomeElderlyInfoDO> getElderlyInfoList(YkElderlyInfoExportReqVO exportReqVO);

    void batchConfirm(YkMealBatchConfirmReqVO reqVO);

    PageResult<YkElderlyDeliveryDO> getDeliveryHistoryPage(YkElderlyDeliveryHistoryPageReqVO pageReqVO);

    List<YkElderlyDeliveryHistoryRespVO> getTodayMealList();

    void recordDeliveryFee(YkDeliveryFeeRecordReqVO reqVO);

    String importExpenseRecord(List<YkElderlyExpenseRecordImportVO> dataList);
    String importRecharge(List<YkElderlyExpenseRecordWeChatImportVO> dataList);

    void updateBalance(YkBalanceUpdateReqVO reqVO);

    void updateDeliveryFee(YkBalanceUpdateReqVO reqVO);

    void confirmFinanceData(YkFinanceConfirmReqVO reqVO);

    PageResult<YkElderlyExpenseRecordDO> getBalanceRecordPage(YkBalanceRecordPageReqVO pageReqVO);

    PageResult<YkElderlyMealRespVO> getElderlyMealPage(YkElderlyMealPageReqVO pageReqVO);

    void updateStandard(YkMealUpdateStandardReqVO reqVO);

    /**
     * 批量删除长者信息
     *
     * @param ids 编号列表
     */
    void batchDeleteElderlyInfo(List<Long> ids);

    /**
     * 批量删除财务变动记录
     *
     * @param ids 编号列表
     */
    void batchDeleteExpenseRecord(List<Long> ids);

    /**
     * 批量删除送餐记录
     *
     * @param ids 编号列表
     */
    void batchDeleteDeliveryRecord(List<Long> ids);

    /**
     * 自动确认
     * @param paymentRecord
     * @return
     */
    String autoConfirmPaymentRecord(YkElderlyPaymentRecordDO paymentRecord);
}